import Migration from "../../db/Migration";
import {Connection} from "mysql";
import ModelFactory from "../../db/ModelFactory";
import User from "../models/User";
import UserApprovedComponent from "../models/UserApprovedComponent";

export default class AddApprovedFieldToUsersTable extends Migration {
    public async install(connection: Connection): Promise<void> {
        await this.query('ALTER TABLE users ADD COLUMN approved BOOLEAN NOT NULL DEFAULT 0', connection);
    }

    public async rollback(connection: Connection): Promise<void> {
        await this.query('ALTER TABLE users DROP COLUMN approved', connection);
    }

    public registerModels(): void {
        ModelFactory.get(User).addComponent(UserApprovedComponent);
    }
}